import { EntityRepository, Repository } from "typeorm";
import { UpdateAboutPageSectionThreeCmsDto } from "./dto/update-about-page-section-three-cms.dto";
import { AboutPageSectionThreeCmsEntity } from "./entities/about-page-section-three-cms.entity";

@EntityRepository(AboutPageSectionThreeCmsEntity)
export class AboutPageSectionThreeCmsRepository extends Repository<AboutPageSectionThreeCmsEntity> {

    async createEntity(dto: UpdateAboutPageSectionThreeCmsDto): Promise<AboutPageSectionThreeCmsEntity | Error> {
        try {
            const entity = this.create({
                image: dto.image,
                title: dto.title,
                subTitle: dto.subTitle,
                buttonText: dto.buttonText,
                buttonLink: dto.buttonLink
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateAboutPageSectionThreeCmsDto, id: string): Promise<AboutPageSectionThreeCmsEntity | Error> {
        try {
            await this.update(id, {
                image: dto.image,
                title: dto.title,
                subTitle: dto.subTitle,
                buttonText: dto.buttonText,
                buttonLink: dto.buttonLink
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<AboutPageSectionThreeCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}