import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { CartCounterCmsService } from "./cart-counter-cms.service";
import { UpdateCartCounterCmsDto } from "./dto/update-cart-counter-cms.dto";

@Controller({ path: "cart-counter-cms", version: Constants.API_VERSION_1 })

export class CartCounterCmsController {
    constructor(private readonly service: CartCounterCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateCartCounterCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
