import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { HeaderBannerCmsService } from "./header-banner-cms.service";
import { UpdateHeaderBannerCmsDto } from "./dto/update-header-banner-cms.dto";

@Controller({ path: "header-banner-cms", version: Constants.API_VERSION_1 })

export class HeaderBannerCmsController {
    constructor(private readonly service: HeaderBannerCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateHeaderBannerCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
