import { Module } from "@nestjs/common";
import { TypeOrmModule } from "@nestjs/typeorm";
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { FileUploadsService } from "src/modules/file-uploads/file-uploads.service";
import { DoSpacesService } from "src/modules/SpacesModule/SpacesService/doSpacesService";
import { DoSpacesServicerovider } from "src/modules/SpacesModule/SpacesService";
import { NewsletterPopupCmsRepository } from "./newsletter-popup-cms.repository";
import { NewsletterPopupCmsController } from "./newsletter-popup-cms.controller";
import { NewsletterPopupCmsService } from "./newsletter-popup-cms.service";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([NewsletterPopupCmsRepository])
    ],
    controllers: [NewsletterPopupCmsController],
    providers: [NewsletterPopupCmsService, JwtHelper, FileUploadsService, DoSpacesService, DoSpacesServicerovider]
})

export class NewsletterPopupCmsModule {}