import {
    Body,
    Controller,
    Get,
    HttpCode,
    HttpStatus,
    Post,
    UseGuards
} from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { OfferPageBadgeToggleCmsService } from "./offer-page-badge-toggle-cms.service";
import { UpdateOfferPageBadgeToggleCmsDto } from "./dto/update-offer-page-badge-toggle-cms.dto";

@Controller({ path: "offer-page-badge-toggle-cms", version: Constants.API_VERSION_1 })

export class OfferPageBadgeToggleCmsController {
    constructor(private readonly service: OfferPageBadgeToggleCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateOfferPageBadgeToggleCmsDto,
      
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
