import { EntityRepository, Repository } from "typeorm";
import { UpdateOfferPageBadgeToggleCmsDto } from "./dto/update-offer-page-badge-toggle-cms.dto";
import { OfferPageBadgeToggleCms } from "./entities/offer-page-badge-toggle-cms.entity";

@EntityRepository(OfferPageBadgeToggleCms)
export class OfferPageBadgeToggleCmsRepository extends Repository<OfferPageBadgeToggleCms> {

    async createEntity(dto: UpdateOfferPageBadgeToggleCmsDto): Promise<OfferPageBadgeToggleCms | Error> {
        try {
            const entity = this.create({
                discountBadge: dto.discountBadge,
                allDiscountBadge: dto.allDiscountBadge
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateOfferPageBadgeToggleCmsDto, id: string): Promise<OfferPageBadgeToggleCms | Error> {
        try {
            await this.update(id, {
                discountBadge: dto.discountBadge,
                allDiscountBadge: dto.allDiscountBadge
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<OfferPageBadgeToggleCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }

}