import { Module } from "@nestjs/common";
import { TypeOrmModule } from "@nestjs/typeorm";
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { PageSchemaRepository } from "./page-schema.repository";
import { PageSchemaController } from "./page-schema.controller";
import { PageSchemaService } from "./page-schema.service";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([PageSchemaRepository])
    ],
    controllers: [PageSchemaController],
    providers: [PageSchemaService, JwtHelper]
})
export class PageSchemaModule {
}