import { EntityRepository, Repository } from "typeorm";
import { UpdatePickupDeliveryCmsDto } from "./dto/update-pickup-delivery-cms.dto";
import { PickupDeliveryCms } from "./entities/pickup-delivery-cms.entity";

@EntityRepository(PickupDeliveryCms)
export class PickupDeliveryCmsRepository extends Repository<PickupDeliveryCms> {

    async createEntity(dto: UpdatePickupDeliveryCmsDto): Promise<PickupDeliveryCms | Error> {
        try {
            const entity = this.create({ ...dto });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdatePickupDeliveryCmsDto, id: string): Promise<PickupDeliveryCms | Error> {
        try {
            await this.update(id, { ...dto });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<PickupDeliveryCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}