import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { RegisterPageCmsService } from "./register-page-cms.service";
import { RegisterPageCmsDto } from "./dto/register-page-cms.dto";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";

@Controller({ path: "register-page-cms", version: Constants.API_VERSION_1 })
export class RegisterPageCmsController {
    constructor(private readonly service: RegisterPageCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: RegisterPageCmsDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    findAll() {
        return this.service.findAll();
    }
}
