import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { RobotCmsDto } from "./dto/robot-cms.dto";
import { RobotCmsService } from "./robot-cms.service";

@Controller({ path: "robot-cms", version: Constants.API_VERSION_1 })
export class RobotCmsController {
    constructor(private readonly service: RobotCmsService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(@Body() dto: RobotCmsDto) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    findAll() {
        return this.service.findAll();
    }
}
