import { EntityRepository, Repository } from "typeorm";
import { UpdateStepsSectionCmsDto } from "./dto/update-steps-section-cms.dto";
import { StepsSectionCmsEntity } from "./entities/steps-section-cms.entity";

@EntityRepository(StepsSectionCmsEntity)
export class StepsSectionCmsRepository extends Repository<StepsSectionCmsEntity> {

    async createEntity(dto: UpdateStepsSectionCmsDto): Promise<StepsSectionCmsEntity | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                subTitle: dto.subTitle,
                countOneImage: dto.countOneImage,
                countOneTitle: dto.countOneTitle,
                countOneDescription: dto.countOneDescription,
                countTwoImage: dto.countTwoImage,
                countTwoTitle: dto.countTwoTitle,
                countTwoDescription: dto.countTwoDescription,
                countThreeImage: dto.countThreeImage,
                countThreeTitle: dto.countThreeTitle,
                countThreeDescription: dto.countThreeDescription
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateStepsSectionCmsDto, id: string): Promise<StepsSectionCmsEntity | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                subTitle: dto.subTitle,
                countOneImage: dto.countOneImage,
                countOneTitle: dto.countOneTitle,
                countOneDescription: dto.countOneDescription,
                countTwoImage: dto.countTwoImage,
                countTwoTitle: dto.countTwoTitle,
                countTwoDescription: dto.countTwoDescription,
                countThreeImage: dto.countThreeImage,
                countThreeTitle: dto.countThreeTitle,
                countThreeDescription: dto.countThreeDescription
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<StepsSectionCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}