import { EntityRepository, Repository } from "typeorm";
import { UpdateUserPageBannerCmsDto } from "./dto/update-home-page-section-seven-cms.dto";
import { UserPageBannerCms } from "./entities/user-page-banner-cms.entity";

@EntityRepository(UserPageBannerCms)
export class UserPageBannerCmsRepository extends Repository<UserPageBannerCms> {

    async createEntity(dto: UpdateUserPageBannerCmsDto): Promise<UserPageBannerCms | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                subTitle: dto.subTitle,
                image: dto.image,
                imageBackgroundColor: dto.imageBackgroundColor,
                bgColor: dto.bgColor,
                isImageOrColor: dto.isImageOrColor,
                buttonText: dto.buttonText,
                buttonLink: dto.buttonLink,
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateUserPageBannerCmsDto, id: string): Promise<UserPageBannerCms | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                subTitle: dto.subTitle,
                image: dto.image,
                imageBackgroundColor: dto.imageBackgroundColor,
                bgColor: dto.bgColor,
                isImageOrColor: dto.isImageOrColor,
                buttonText: dto.buttonText,
                buttonLink: dto.buttonLink,
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<UserPageBannerCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}