import { EntityRepository, Repository } from "typeorm";
import { UpdateWeeklyAdCmsDto } from "./dto/update-weekly-ad-cms.dto";
import { WeeklyAdCms } from "./entities/weekly-ad-cms.entity";

@EntityRepository(WeeklyAdCms)
export class WeeklyAdCmsRepository extends Repository<WeeklyAdCms> {

    async createEntity(dto: UpdateWeeklyAdCmsDto): Promise<WeeklyAdCms | Error> {
        try {
            const entity = this.create({
                title: dto.title,
                subTitle: dto.subTitle,
                buttonText: dto.buttonText,
                placeholderText: dto.placeholderText
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateWeeklyAdCmsDto, id: string): Promise<WeeklyAdCms | Error> {
        try {
            await this.update(id, {
                title: dto.title,
                subTitle: dto.subTitle,
                buttonText: dto.buttonText,
                placeholderText: dto.placeholderText
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<WeeklyAdCms[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}