import { Module } from "@nestjs/common";
import { TypeOrmModule } from "@nestjs/typeorm";
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { FileUploadsService } from "src/modules/file-uploads/file-uploads.service";
import { DoSpacesService } from "src/modules/SpacesModule/SpacesService/doSpacesService";
import { DoSpacesServicerovider } from "src/modules/SpacesModule/SpacesService";
import { ArticleCategoryRepository } from "./article-category.repository";
import { ArticleCategoryController } from "./article-category.controller";
import { ArticleCategoryService } from "./article-category.service";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([ArticleCategoryRepository])
    ],
    controllers: [ArticleCategoryController],
    providers: [ArticleCategoryService, JwtHelper, FileUploadsService, DoSpacesService, DoSpacesServicerovider]
})
export class ArticleCategoryModule {
}