import { EntityRepository, Repository } from "typeorm";
import { UpdateDealsPageUiDto } from "./dto/update-deals-page-ui.dto";
import { DealsPageUI } from "./entities/deals-page-ui.entity";

@EntityRepository(DealsPageUI)
export class DealsPageUiRepository extends Repository<DealsPageUI> {

    async createEntity(dto: UpdateDealsPageUiDto): Promise<DealsPageUI | Error> {
        try {
            const entity = this.create({
                pageBackgroundColor: dto.pageBackgroundColor,
                titleFontColor: dto.titleFontColor,
                categoryButtonOneBackgroundColor: dto.categoryButtonOneBackgroundColor,
                categoryButtonTwoBackgroundColor: dto.categoryButtonTwoBackgroundColor,
                categoryButtonOneFontColor: dto.categoryButtonOneFontColor,
                categoryButtonTwoFontColor: dto.categoryButtonTwoFontColor,
                categoryButtonOneBorderColor: dto.categoryButtonOneBorderColor,
                categoryButtonTwoBorderColor: dto.categoryButtonTwoBorderColor
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateDealsPageUiDto, id: string): Promise<DealsPageUI | Error> {
        try {
            await this.update(id, {
                pageBackgroundColor: dto.pageBackgroundColor,
                titleFontColor: dto.titleFontColor,
                categoryButtonOneBackgroundColor: dto.categoryButtonOneBackgroundColor,
                categoryButtonTwoBackgroundColor: dto.categoryButtonTwoBackgroundColor,
                categoryButtonOneFontColor: dto.categoryButtonOneFontColor,
                categoryButtonTwoFontColor: dto.categoryButtonTwoFontColor,
                categoryButtonOneBorderColor: dto.categoryButtonOneBorderColor,
                categoryButtonTwoBorderColor: dto.categoryButtonTwoBorderColor
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<DealsPageUI[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}