import { EntityRepository, Repository } from "typeorm";
import { UpdateHomePageUiDto } from "./dto/update-home-page-ui.dto";
import { HomePageUI } from "./entities/home-page-ui.entity";


@EntityRepository(HomePageUI)
export class HomePageUiRepository extends Repository<HomePageUI> {

    async createEntity(dto: UpdateHomePageUiDto): Promise<HomePageUI | Error> {
        try {
            const entity = this.create({
                pageBackgroundColor: dto.pageBackgroundColor,
                highFiveSectionBackgroundColor: dto.highFiveSectionBackgroundColor,
                highFiveSectionTitleFontColor: dto.highFiveSectionTitleFontColor,
                highFiveSectionSubtitleFontColor: dto.highFiveSectionSubtitleFontColor,
                shopByPriceSectionBackgroundColor: dto.shopByPriceSectionBackgroundColor,
                shopByPriceSectionTitleFontColor: dto.shopByPriceSectionTitleFontColor,
                shopByPriceSectionSubtitleFontColor: dto.shopByPriceSectionSubtitleFontColor,
                newDropsSectionBackgroundColor: dto.newDropsSectionBackgroundColor,
                newDropsSectionTitleFontColor: dto.newDropsSectionTitleFontColor,
                newDropsSectionSubtitleFontColor: dto.newDropsSectionSubtitleFontColor,
                newDropsSectionButtonFontColor: dto.newDropsSectionButtonFontColor,
                higherSelfSectionBackgroundColor: dto.higherSelfSectionBackgroundColor,
                higherSelfSectionTitleFontColor: dto.higherSelfSectionTitleFontColor,
                higherSelfSectionSubtitleFontColor: dto.higherSelfSectionSubtitleFontColor,
                higherSelfSectionButtonFontColor: dto.higherSelfSectionButtonFontColor,
                higherSelfSectionCardOneBackgroundColor: dto.higherSelfSectionCardOneBackgroundColor,
                higherSelfSectionCardOneTitleFontColor: dto.higherSelfSectionCardOneTitleFontColor,
                higherSelfSectionCardOneSubtitleFontColor: dto.higherSelfSectionCardOneSubtitleFontColor,
                higherSelfSectionCardTwoBackgroundColor: dto.higherSelfSectionCardTwoBackgroundColor,
                higherSelfSectionCardTwoTitleFontColor: dto.higherSelfSectionCardTwoTitleFontColor,
                higherSelfSectionCardTwoSubtitleFontColor: dto.higherSelfSectionCardTwoSubtitleFontColor,
                higherSelfSectionCardThreeBackgroundColor: dto.higherSelfSectionCardThreeBackgroundColor,
                higherSelfSectionCardThreeTitleFontColor: dto.higherSelfSectionCardThreeTitleFontColor,
                higherSelfSectionCardThreeSubtitleFontColor: dto.higherSelfSectionCardThreeSubtitleFontColor,
                higherSelfSectionCardFourBackgroundColor: dto.higherSelfSectionCardFourBackgroundColor,
                higherSelfSectionCardFourTitleFontColor: dto.higherSelfSectionCardFourTitleFontColor,
                higherSelfSectionCardFourSubtitleFontColor: dto.higherSelfSectionCardFourSubtitleFontColor,
                higherSelfSectionCardButtonBackgroundColor: dto.higherSelfSectionCardButtonBackgroundColor,
                higherSelfSectionCardButtonFontColor: dto.higherSelfSectionCardButtonFontColor,
                higherSelfSectionCardButtonBorderColor: dto.higherSelfSectionCardButtonBorderColor,
                higherSelfSectionCardButtonHoverBackgroundColor: dto.higherSelfSectionCardButtonHoverBackgroundColor,
                higherSelfSectionCardButtonHoverFontColor: dto.higherSelfSectionCardButtonHoverFontColor,
                higherSelfSectionCardButtonHoverBorderColor: dto.higherSelfSectionCardButtonHoverBorderColor,
                sunnyDazeSectionBackgroundColor: dto.sunnyDazeSectionBackgroundColor,
                sunnyDazeSectionTitleFontColor: dto.sunnyDazeSectionTitleFontColor,
                sunnyDazeSectionSubtitleFontColor: dto.sunnyDazeSectionSubtitleFontColor,
                sunnyDazeSectionButtonFontColor: dto.sunnyDazeSectionButtonFontColor,
                shopOurInventorySectionBackgroundColor: dto.shopOurInventorySectionBackgroundColor,
                shopOurInventorySectionTitleFontColor: dto.shopOurInventorySectionTitleFontColor,
                shopOurInventorySectionSubtitleFontColor: dto.shopOurInventorySectionSubtitleFontColor,
                highFiveSectionButtonBackgroundColor: dto.highFiveSectionButtonBackgroundColor,
                highFiveSectionButtonFontColor: dto.highFiveSectionButtonFontColor,
                highFiveSectionButtonBorderColor: dto.highFiveSectionButtonBorderColor,
                newDropsSectionButtonBackgroundColor: dto.newDropsSectionButtonBackgroundColor,
                newDropsSectionButtonMobileFontColor: dto.newDropsSectionButtonMobileFontColor,
                newDropsSectionButtonBorderColor: dto.newDropsSectionButtonBorderColor,
                shopByPriceSectionButtonBackgroundColor: dto.shopByPriceSectionButtonBackgroundColor,
                shopByPriceSectionButtonFontColor: dto.shopByPriceSectionButtonFontColor,
                shopByPriceSectionButtonBorderColor: dto.shopByPriceSectionButtonBorderColor,
                sunnyDazeSectionButtonBackgroundColor: dto.sunnyDazeSectionButtonBackgroundColor,
                sunnyDazeSectionButtonMobileFontColor: dto.sunnyDazeSectionButtonMobileFontColor,
                sunnyDazeSectionButtonBorderColor: dto.sunnyDazeSectionButtonBorderColor
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateHomePageUiDto, id: string): Promise<HomePageUI | Error> {
        try {
            await this.update(id, {
                pageBackgroundColor: dto.pageBackgroundColor,
                highFiveSectionBackgroundColor: dto.highFiveSectionBackgroundColor,
                highFiveSectionTitleFontColor: dto.highFiveSectionTitleFontColor,
                highFiveSectionSubtitleFontColor: dto.highFiveSectionSubtitleFontColor,
                shopByPriceSectionBackgroundColor: dto.shopByPriceSectionBackgroundColor,
                shopByPriceSectionTitleFontColor: dto.shopByPriceSectionTitleFontColor,
                shopByPriceSectionSubtitleFontColor: dto.shopByPriceSectionSubtitleFontColor,
                newDropsSectionBackgroundColor: dto.newDropsSectionBackgroundColor,
                newDropsSectionTitleFontColor: dto.newDropsSectionTitleFontColor,
                newDropsSectionSubtitleFontColor: dto.newDropsSectionSubtitleFontColor,
                newDropsSectionButtonFontColor: dto.newDropsSectionButtonFontColor,
                higherSelfSectionBackgroundColor: dto.higherSelfSectionBackgroundColor,
                higherSelfSectionTitleFontColor: dto.higherSelfSectionTitleFontColor,
                higherSelfSectionSubtitleFontColor: dto.higherSelfSectionSubtitleFontColor,
                higherSelfSectionButtonFontColor: dto.higherSelfSectionButtonFontColor,
                higherSelfSectionCardOneBackgroundColor: dto.higherSelfSectionCardOneBackgroundColor,
                higherSelfSectionCardOneTitleFontColor: dto.higherSelfSectionCardOneTitleFontColor,
                higherSelfSectionCardOneSubtitleFontColor: dto.higherSelfSectionCardOneSubtitleFontColor,
                higherSelfSectionCardTwoBackgroundColor: dto.higherSelfSectionCardTwoBackgroundColor,
                higherSelfSectionCardTwoTitleFontColor: dto.higherSelfSectionCardTwoTitleFontColor,
                higherSelfSectionCardTwoSubtitleFontColor: dto.higherSelfSectionCardTwoSubtitleFontColor,
                higherSelfSectionCardThreeBackgroundColor: dto.higherSelfSectionCardThreeBackgroundColor,
                higherSelfSectionCardThreeTitleFontColor: dto.higherSelfSectionCardThreeTitleFontColor,
                higherSelfSectionCardThreeSubtitleFontColor: dto.higherSelfSectionCardThreeSubtitleFontColor,
                higherSelfSectionCardFourBackgroundColor: dto.higherSelfSectionCardFourBackgroundColor,
                higherSelfSectionCardFourTitleFontColor: dto.higherSelfSectionCardFourTitleFontColor,
                higherSelfSectionCardFourSubtitleFontColor: dto.higherSelfSectionCardFourSubtitleFontColor,
                higherSelfSectionCardButtonBackgroundColor: dto.higherSelfSectionCardButtonBackgroundColor,
                higherSelfSectionCardButtonFontColor: dto.higherSelfSectionCardButtonFontColor,
                higherSelfSectionCardButtonBorderColor: dto.higherSelfSectionCardButtonBorderColor,
                higherSelfSectionCardButtonHoverBackgroundColor: dto.higherSelfSectionCardButtonHoverBackgroundColor,
                higherSelfSectionCardButtonHoverFontColor: dto.higherSelfSectionCardButtonHoverFontColor,
                higherSelfSectionCardButtonHoverBorderColor: dto.higherSelfSectionCardButtonHoverBorderColor,
                sunnyDazeSectionBackgroundColor: dto.sunnyDazeSectionBackgroundColor,
                sunnyDazeSectionTitleFontColor: dto.sunnyDazeSectionTitleFontColor,
                sunnyDazeSectionSubtitleFontColor: dto.sunnyDazeSectionSubtitleFontColor,
                sunnyDazeSectionButtonFontColor: dto.sunnyDazeSectionButtonFontColor,
                shopOurInventorySectionBackgroundColor: dto.shopOurInventorySectionBackgroundColor,
                shopOurInventorySectionTitleFontColor: dto.shopOurInventorySectionTitleFontColor,
                shopOurInventorySectionSubtitleFontColor: dto.shopOurInventorySectionSubtitleFontColor,
                highFiveSectionButtonBackgroundColor: dto.highFiveSectionButtonBackgroundColor,
                highFiveSectionButtonFontColor: dto.highFiveSectionButtonFontColor,
                highFiveSectionButtonBorderColor: dto.highFiveSectionButtonBorderColor,
                newDropsSectionButtonBackgroundColor: dto.newDropsSectionButtonBackgroundColor,
                newDropsSectionButtonMobileFontColor: dto.newDropsSectionButtonMobileFontColor,
                newDropsSectionButtonBorderColor: dto.newDropsSectionButtonBorderColor,
                shopByPriceSectionButtonBackgroundColor: dto.shopByPriceSectionButtonBackgroundColor,
                shopByPriceSectionButtonFontColor: dto.shopByPriceSectionButtonFontColor,
                shopByPriceSectionButtonBorderColor: dto.shopByPriceSectionButtonBorderColor,
                sunnyDazeSectionButtonBackgroundColor: dto.sunnyDazeSectionButtonBackgroundColor,
                sunnyDazeSectionButtonMobileFontColor: dto.sunnyDazeSectionButtonMobileFontColor,
                sunnyDazeSectionButtonBorderColor: dto.sunnyDazeSectionButtonBorderColor
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<HomePageUI[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}