import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { NewsletterPopupUiService } from "./newsletter-popup-ui.service";
import { UpdateNewsletterPopupUiDto } from "./dto/update-newsletter-popup-ui.dto";

@Controller({ path: "newsletter-popup-component-ui", version: Constants.API_VERSION_1 })

export class NewsletterPopupUiController {
    constructor(private readonly service: NewsletterPopupUiService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateNewsletterPopupUiDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
