import { EntityRepository, Repository } from "typeorm";
import { UpdateNewsletterPopupUiDto } from "./dto/update-newsletter-popup-ui.dto";
import { NewsletterPopupUI } from "./entities/newsletter-popup-ui.entity";

@EntityRepository(NewsletterPopupUI)
export class NewsletterPopupUiRepository extends Repository<NewsletterPopupUI> {

    async createEntity(dto: UpdateNewsletterPopupUiDto): Promise<NewsletterPopupUI | Error> {
        try {
            const entity = this.create({
                popupbackgroundColor: dto.popupbackgroundColor,
                headingFontColor: dto.headingFontColor,
                titleFontColor: dto.titleFontColor,
                subTitleFontColor: dto.subTitleFontColor,
                inputFontColor: dto.inputFontColor,
                buttonOneBackgroundColor: dto.buttonOneBackgroundColor,
                buttonOneFontColor: dto.buttonOneFontColor,
                buttonTwoFontColor: dto.buttonTwoFontColor,
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateNewsletterPopupUiDto, id: string): Promise<NewsletterPopupUI | Error> {
        try {
            await this.update(id, {
                popupbackgroundColor: dto.popupbackgroundColor,
                headingFontColor: dto.headingFontColor,
                titleFontColor: dto.titleFontColor,
                subTitleFontColor: dto.subTitleFontColor,
                inputFontColor: dto.inputFontColor,
                buttonOneBackgroundColor: dto.buttonOneBackgroundColor,
                buttonOneFontColor: dto.buttonOneFontColor,
                buttonTwoFontColor: dto.buttonTwoFontColor,
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<NewsletterPopupUI[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}