import { Body, Controller, Get, HttpCode, HttpStatus, Post, UseGuards } from "@nestjs/common";
import { AdminAuthGuard } from "src/core/guards/admin-auth.guard";
import { Constants } from "src/utils/constants";
import { RegisterPageUiService } from "./register-page-ui.service";
import { UpdateRegisterPageUiDto } from "./dto/update-register-page-ui.dto";

@Controller({ path: "register-component-ui", version: Constants.API_VERSION_1 })

export class RegisterPageUiController {
    constructor(private readonly service: RegisterPageUiService) {
    }

    @Post()
    @HttpCode(HttpStatus.OK)
    @UseGuards(AdminAuthGuard)
    updateOrCreateData(
      @Body() dto: UpdateRegisterPageUiDto
    ) {
        return this.service.updateOrCreateData(dto);
    }

    @Get()
    // @UseGuards(AdminAuthGuard)
    findAll() {
        return this.service.findAll();
    }
}
