import { EntityRepository, Repository } from "typeorm";
import { UpdateRegisterPageUiDto } from "./dto/update-register-page-ui.dto";
import { RegisterPageUI } from "./entities/register-page-ui.entity";

@EntityRepository(RegisterPageUI)
export class RegisterPageUiRepository extends Repository<RegisterPageUI> {

    async createEntity(dto: UpdateRegisterPageUiDto): Promise<RegisterPageUI | Error> {
        try {
            const entity = this.create({
                backgroundColor: dto.backgroundColor,
                titleFontColor: dto.titleFontColor,
                buttonColor: dto.buttonColor,
                buttonFontColor: dto.buttonFontColor,
                bottomOneFontColor: dto.bottomOneFontColor,
                bottomTwoFontColor: dto.bottomTwoFontColor
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async updateEntity(dto: UpdateRegisterPageUiDto, id: string): Promise<RegisterPageUI | Error> {
        try {
            await this.update(id, {
                backgroundColor: dto.backgroundColor,
                titleFontColor: dto.titleFontColor,
                buttonColor: dto.buttonColor,
                buttonFontColor: dto.buttonFontColor,
                bottomOneFontColor: dto.bottomOneFontColor,
                bottomTwoFontColor: dto.bottomTwoFontColor
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<RegisterPageUI[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}