import { Module } from "@nestjs/common";
import { StateWiseProductCategoryService } from "./state-wise-product-category.service";
import { StateWiseProductCategoryController } from "./state-wise-product-category.controller";
import { TypeOrmModule } from "@nestjs/typeorm";
import { StateWiseProductCategoryRepository } from "./state-wise-product-category.repository";
import { JwtModule } from "@nestjs/jwt";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { DoSpacesService } from "src/modules/SpacesModule/SpacesService/doSpacesService";
import { DoSpacesServicerovider } from "src/modules/SpacesModule/SpacesService";
import { ProductCategoryRepository } from "../product-category/product-category.repository";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([StateWiseProductCategoryRepository, ProductCategoryRepository])
    ],
    controllers: [StateWiseProductCategoryController],
    providers: [StateWiseProductCategoryService, JwtHelper, DoSpacesService, DoSpacesServicerovider]
})
export class StateWiseProductCategoryModule {
}