import { Module } from "@nestjs/common";
import { DutchiePlusProductService } from "./dutchie-plus-product.service";
import { DutchiePlusProductController } from "./dutchie-plus-product.controller";
import { DutchiePlusRetailerService } from "../dutchie-plus-retailer/dutchie-plus-retailer.service";
import { TypeOrmModule } from "@nestjs/typeorm";
import {
    ProductCategoryRepository
} from "src/modules/dutchie-plus/custom-services/product-category/product-category.repository";
import { RetailerServiceRepository } from "../custom-services/retailer-service/retailer-service.repository";
import { ProductEffectsRepository } from "../custom-services/product-effects/product-effects.repository";
import { ProductServiceRepository } from "../custom-services/product-service/product-service.repository";
import { StateWiseProductCategoryRepository } from "../custom-services/state-wise-product-category/state-wise-product-category.repository";

@Module({
    imports: [
        TypeOrmModule.forFeature([
            ProductCategoryRepository,
            RetailerServiceRepository,
            ProductEffectsRepository,
            ProductServiceRepository,
            StateWiseProductCategoryRepository
        ])
    ],
    controllers: [DutchiePlusProductController],
    providers: [DutchiePlusProductService, DutchiePlusRetailerService]
})
export class DutchiePlusProductModule {
}
