import { Body, Controller, Get, HttpCode, HttpStatus, Post, Query } from "@nestjs/common";
import { DutchiePlusRetailerService } from "./dutchie-plus-retailer.service";
import { Constants } from "src/utils/constants";

@Controller({
    path: "retailer",
    version: Constants.API_VERSION_1
})
export class DutchiePlusRetailerController {
    constructor(private readonly dutchiePlusRetailerService: DutchiePlusRetailerService) {
    }

    @Post("/all")
    @HttpCode(HttpStatus.OK)
    findAll(
      @Query("type") type?: string,
      @Query("search") search?: string
    ) {
        return this.dutchiePlusRetailerService.findAll(type, search);
    }

    @Get("/all-state")
    findAllState() {
        return this.dutchiePlusRetailerService.findAllState();
    }


    @Post("/filter-all")
    @HttpCode(HttpStatus.OK)
    filterRetailer(
      @Body() variables: any,
      @Query("type") type?: string,
      @Query("search") search?: string
    ) {
        return this.dutchiePlusRetailerService.filterRetailer(variables, type, search);
    }

    @Post("/details")
    @HttpCode(HttpStatus.OK)
    findOne(@Body() variables: any) {
        return this.dutchiePlusRetailerService.findOne(variables);
    }
}
