import {
    Body,
    Controller,
    HttpCode,
    HttpStatus,
    Post
} from "@nestjs/common";
import { Constants } from "src/utils/constants";
import { CartServiceIHeartJaneService } from "./cart-service-iheartjane.service";

@Controller({ path: "cart-iheartjane", version: Constants.API_VERSION_1 })

export class CartServiceIHeartJaneController {
    constructor(private readonly cartServiceIHeartJaneService: CartServiceIHeartJaneService) {
    }

    @Post("/create")
    @HttpCode(HttpStatus.OK)
    createCheckout(@Body() variables: any) {
        return this.cartServiceIHeartJaneService.createCart(variables);
    }

    @Post("/add-item")
    @HttpCode(HttpStatus.OK)
    addItemToCheckout(@Body() variables: any) {
        return this.cartServiceIHeartJaneService.addItemToCheckout(variables);
    }

    @Post("/remove-item")
    @HttpCode(HttpStatus.OK)
    removeItemFromCheckout(@Body() variables: any) {
        return this.cartServiceIHeartJaneService.removeItemFromCheckout(variables);
    }

    @Post("/update-quantity")
    @HttpCode(HttpStatus.OK)
    updateQuantity(@Body() variables: any) {
        return this.cartServiceIHeartJaneService.updateQuantity(variables);
    }

    @Post("/cart-details")
    @HttpCode(HttpStatus.OK)
    fetchCartDetails(@Body() variables: any) {
        return this.cartServiceIHeartJaneService.fetchCartDetails(variables);
    }
}