import { EntityRepository, Repository } from "typeorm";
import { UpdatePageMetaCmsDto } from "./dto/update-page-meta-cms.dto";
import { PageMetaCmsEntity } from "./entities/page-meta-cms.entity";

@EntityRepository(PageMetaCmsEntity)
export class PageMetaCmsRepository extends Repository<PageMetaCmsEntity> {

    async createEntity(dto: UpdatePageMetaCmsDto): Promise<PageMetaCmsEntity | Error> {
        try {
            const entity = this.create({
                signinPageMetaKeyword: dto.signinPageMetaKeyword,
                signinPageMetaDescription: dto.signinPageMetaDescription,
                signupPageMetaKeyword: dto.signupPageMetaKeyword,
                signupPageMetaDescription: dto.signupPageMetaDescription,
                homePageMetaKeyword: dto.homePageMetaKeyword,
                homePageMetaDescription: dto.homePageMetaDescription,
                shopPageMetaKeyword: dto.shopPageMetaKeyword,
                shopPageMetaDescription: dto.shopPageMetaDescription,
                specialPageMetaKeyword: dto.specialPageMetaKeyword,
                specialPageMetaDescription: dto.specialPageMetaDescription,
                productDetailsPageMetaKeyword: dto.productDetailsPageMetaKeyword,
                productDetailsPageMetaDescription: dto.productDetailsPageMetaDescription,
                cartPageMetaKeyword: dto.cartPageMetaKeyword,
                cartPageMetaDescription: dto.cartPageMetaDescription,
                dailyDealsPageMetaKeyword: dto.dailyDealsPageMetaKeyword,
                dailyDealsPageMetaDescription: dto.dailyDealsPageMetaDescription,
                jarsPlusPageMetaKeyword: dto.jarsPlusPageMetaKeyword,
                jarsPlusPageMetaDescription: dto.jarsPlusPageMetaDescription,
                aboutUsPageMetaKeyword: dto.aboutUsPageMetaKeyword,
                aboutUsPageMetaDescription: dto.aboutUsPageMetaDescription,
                articlesPageMetaKeyword: dto.articlesPageMetaKeyword,
                articlesPageMetaDescription: dto.articlesPageMetaDescription,
                articleDetailsPageMetaKeyword: dto.articleDetailsPageMetaKeyword,
                articleDetailsPageMetaDescription: dto.articleDetailsPageMetaDescription,
                pressReleasePageMetaKeyword: dto.pressReleasePageMetaKeyword,
                pressReleasePageMetaDescription: dto.pressReleasePageMetaDescription,
                pressReleaseDetailsPageMetaKeyword: dto.pressReleaseDetailsPageMetaKeyword,
                pressReleaseDetailsPageMetaDescription: dto.pressReleaseDetailsPageMetaDescription,
                contactUsPageMetaKeyword: dto.contactUsPageMetaKeyword,
                contactUsPageMetaDescription: dto.contactUsPageMetaDescription,
                faqPageMetaKeyword: dto.faqPageMetaKeyword,
                faqPageMetaDescription: dto.faqPageMetaDescription,
                careerPageMetaKeyword: dto.careerPageMetaKeyword,
                careerPageMetaDescription: dto.careerPageMetaDescription,
                careerDepartmentPageMetaKeyword: dto.careerDepartmentPageMetaKeyword,
                careerDepartmentPageMetaDescription: dto.careerDepartmentPageMetaDescription,
                careerDetailsPageMetaKeyword: dto.careerDetailsPageMetaKeyword,
                careerDetailsPageMetaDescription: dto.careerDetailsPageMetaDescription,
                privacyPageMetaKeyword: dto.privacyPageMetaKeyword,
                privacyPageMetaDescription: dto.privacyPageMetaDescription,
                termsPageMetaKeyword: dto.termsPageMetaKeyword,
                termsPageMetaDescription: dto.termsPageMetaDescription,
                cookiesSettingsPageMetaKeyword: dto.cookiesSettingsPageMetaKeyword,
                cookiesSettingsPageMetaDescription: dto.cookiesSettingsPageMetaDescription,
                profilePageMetaKeyword: dto.profilePageMetaKeyword,
                profilePageMetaDescription: dto.profilePageMetaDescription,
                successPageMetaKeyword: dto.successPageMetaKeyword,
                successPageMetaDescription: dto.successPageMetaDescription,
                storeDetailsPageMetaKeyword: dto.storeDetailsPageMetaKeyword,
                storeDetailsPageMetaDescription: dto.storeDetailsPageMetaDescription,
                retailerPageMetaKeyword: dto.retailerPageMetaKeyword,
                retailerPageMetaDescription: dto.retailerPageMetaDescription,
                orderPageMetaKeyword: dto.orderPageMetaKeyword,
                orderPageMetaDescription: dto.orderPageMetaDescription,
                myItemsPageMetaKeyword: dto.myItemsPageMetaKeyword,
                myItemsPageMetaDescription: dto.myItemsPageMetaDescription,
                getDirectionPageMetaKeyword: dto.getDirectionPageMetaKeyword,
                getDirectionPageMetaDescription: dto.getDirectionPageMetaDescription,
                forgotPasswordPageMetaKeyword: dto.forgotPasswordPageMetaKeyword,
                forgotPasswordPageMetaDescription: dto.forgotPasswordPageMetaDescription,
                reviewPageMetaKeyword: dto.reviewPageMetaKeyword,
                reviewPageMetaDescription: dto.reviewPageMetaDescription,
                resetPasswordPageMetaKeyword: dto.resetPasswordPageMetaKeyword,
                resetPasswordPageMetaDescription: dto.resetPasswordPageMetaDescription,
                invoicePageMetaKeyword: dto.invoicePageMetaKeyword,
                invoicePageMetaDescription: dto.invoicePageMetaDescription,
                categoryPageMetaKeyword: dto.categoryPageMetaKeyword,
                categoryPageMetaDescription: dto.categoryPageMetaDescription,
                ageVerificationPageMetaKeyword: dto.ageVerificationPageMetaKeyword,
                ageVerificationPageMetaDescription: dto.ageVerificationPageMetaDescription,
                weeklyAdPageMetaKeyword: dto.weeklyAdPageMetaKeyword,
                weeklyAdPageMetaDescription: dto.weeklyAdPageMetaDescription,
                dealsJarsPageMetaKeyword: dto.dealsJarsPageMetaKeyword,
                dealsJarsPageMetaDescription: dto.dealsJarsPageMetaDescription,
            });
            await this.save(entity);
            return entity;
        } catch (e) {
            return e;
        }
    }

    async UpdateEntity(dto: UpdatePageMetaCmsDto, id: string): Promise<PageMetaCmsEntity | Error> {
        try {
            await this.update(id, {
                signinPageMetaKeyword: dto.signinPageMetaKeyword,
                signinPageMetaDescription: dto.signinPageMetaDescription,
                signupPageMetaKeyword: dto.signupPageMetaKeyword,
                signupPageMetaDescription: dto.signupPageMetaDescription,
                homePageMetaKeyword: dto.homePageMetaKeyword,
                homePageMetaDescription: dto.homePageMetaDescription,
                shopPageMetaKeyword: dto.shopPageMetaKeyword,
                shopPageMetaDescription: dto.shopPageMetaDescription,
                specialPageMetaKeyword: dto.specialPageMetaKeyword,
                specialPageMetaDescription: dto.specialPageMetaDescription,
                productDetailsPageMetaKeyword: dto.productDetailsPageMetaKeyword,
                productDetailsPageMetaDescription: dto.productDetailsPageMetaDescription,
                cartPageMetaKeyword: dto.cartPageMetaKeyword,
                cartPageMetaDescription: dto.cartPageMetaDescription,
                dailyDealsPageMetaKeyword: dto.dailyDealsPageMetaKeyword,
                dailyDealsPageMetaDescription: dto.dailyDealsPageMetaDescription,
                jarsPlusPageMetaKeyword: dto.jarsPlusPageMetaKeyword,
                jarsPlusPageMetaDescription: dto.jarsPlusPageMetaDescription,
                aboutUsPageMetaKeyword: dto.aboutUsPageMetaKeyword,
                aboutUsPageMetaDescription: dto.aboutUsPageMetaDescription,
                articlesPageMetaKeyword: dto.articlesPageMetaKeyword,
                articlesPageMetaDescription: dto.articlesPageMetaDescription,
                articleDetailsPageMetaKeyword: dto.articleDetailsPageMetaKeyword,
                articleDetailsPageMetaDescription: dto.articleDetailsPageMetaDescription,
                pressReleasePageMetaKeyword: dto.pressReleasePageMetaKeyword,
                pressReleasePageMetaDescription: dto.pressReleasePageMetaDescription,
                pressReleaseDetailsPageMetaKeyword: dto.pressReleaseDetailsPageMetaKeyword,
                pressReleaseDetailsPageMetaDescription: dto.pressReleaseDetailsPageMetaDescription,
                contactUsPageMetaKeyword: dto.contactUsPageMetaKeyword,
                contactUsPageMetaDescription: dto.contactUsPageMetaDescription,
                faqPageMetaKeyword: dto.faqPageMetaKeyword,
                faqPageMetaDescription: dto.faqPageMetaDescription,
                careerPageMetaKeyword: dto.careerPageMetaKeyword,
                careerPageMetaDescription: dto.careerPageMetaDescription,
                careerDepartmentPageMetaKeyword: dto.careerDepartmentPageMetaKeyword,
                careerDepartmentPageMetaDescription: dto.careerDepartmentPageMetaDescription,
                careerDetailsPageMetaKeyword: dto.careerDetailsPageMetaKeyword,
                careerDetailsPageMetaDescription: dto.careerDetailsPageMetaDescription,
                privacyPageMetaKeyword: dto.privacyPageMetaKeyword,
                privacyPageMetaDescription: dto.privacyPageMetaDescription,
                termsPageMetaKeyword: dto.termsPageMetaKeyword,
                termsPageMetaDescription: dto.termsPageMetaDescription,
                cookiesSettingsPageMetaKeyword: dto.cookiesSettingsPageMetaKeyword,
                cookiesSettingsPageMetaDescription: dto.cookiesSettingsPageMetaDescription,
                profilePageMetaKeyword: dto.profilePageMetaKeyword,
                profilePageMetaDescription: dto.profilePageMetaDescription,
                successPageMetaKeyword: dto.successPageMetaKeyword,
                successPageMetaDescription: dto.successPageMetaDescription,
                storeDetailsPageMetaKeyword: dto.storeDetailsPageMetaKeyword,
                storeDetailsPageMetaDescription: dto.storeDetailsPageMetaDescription,
                retailerPageMetaKeyword: dto.retailerPageMetaKeyword,
                retailerPageMetaDescription: dto.retailerPageMetaDescription,
                orderPageMetaKeyword: dto.orderPageMetaKeyword,
                orderPageMetaDescription: dto.orderPageMetaDescription,
                myItemsPageMetaKeyword: dto.myItemsPageMetaKeyword,
                myItemsPageMetaDescription: dto.myItemsPageMetaDescription,
                getDirectionPageMetaKeyword: dto.getDirectionPageMetaKeyword,
                getDirectionPageMetaDescription: dto.getDirectionPageMetaDescription,
                forgotPasswordPageMetaKeyword: dto.forgotPasswordPageMetaKeyword,
                forgotPasswordPageMetaDescription: dto.forgotPasswordPageMetaDescription,
                reviewPageMetaKeyword: dto.reviewPageMetaKeyword,
                reviewPageMetaDescription: dto.reviewPageMetaDescription,
                resetPasswordPageMetaKeyword: dto.resetPasswordPageMetaKeyword,
                resetPasswordPageMetaDescription: dto.resetPasswordPageMetaDescription,
                invoicePageMetaKeyword: dto.invoicePageMetaKeyword,
                invoicePageMetaDescription: dto.invoicePageMetaDescription,
                categoryPageMetaKeyword: dto.categoryPageMetaKeyword,
                categoryPageMetaDescription: dto.categoryPageMetaDescription,
                ageVerificationPageMetaKeyword: dto.ageVerificationPageMetaKeyword,
                ageVerificationPageMetaDescription: dto.ageVerificationPageMetaDescription,
                weeklyAdPageMetaKeyword: dto.weeklyAdPageMetaKeyword,
                weeklyAdPageMetaDescription: dto.weeklyAdPageMetaDescription,
                dealsJarsPageMetaKeyword: dto.dealsJarsPageMetaKeyword,
                dealsJarsPageMetaDescription: dto.dealsJarsPageMetaDescription,
            });
            return await this.findOne(id);
        } catch (e) {
            return e;
        }
    }

    async findAll(): Promise<PageMetaCmsEntity[] | Error> {
        try {
            return await this.find({
                where: {
                    isDeleted: false
                }
            });
        } catch (e) {
            return e;
        }
    }
}