import { Module } from "@nestjs/common";
import { JwtModule } from "@nestjs/jwt";
import { TypeOrmModule } from "@nestjs/typeorm";
import JwtConfigService from "src/core/jwt/jwt-config.service";
import JwtHelper from "src/core/jwt/jwt.helper";
import { UsersRepository } from "src/modules/users/user.repository";
import { WeeklyAdTagsListController } from "./weekly-ad-tags-list.controller";
import { WeeklyAdTagsListRepository } from "./weekly-ad-tags-list.repository";
import { WeeklyAdTagsListService } from "./weekly-ad-tags-list.service";
import { WeeklyAdRepository } from "../weekly-ad/weekly-ad.repository";

@Module({
    imports: [
        JwtModule.registerAsync({
            useClass: JwtConfigService
        }),
        TypeOrmModule.forFeature([UsersRepository]),
        TypeOrmModule.forFeature([WeeklyAdTagsListRepository]),
        TypeOrmModule.forFeature([WeeklyAdRepository])
    ],
    controllers: [WeeklyAdTagsListController],
    providers: [WeeklyAdTagsListService, JwtHelper]
})
export class WeeklyAdTagsListModule {
}
